package iotcloud;

class SlotIndexer {
	private Slot[] updates;
	private SlotBuffer buffer;
	private long firstslotseqnum;

	SlotIndexer(Slot[] _updates, SlotBuffer _buffer) {
		buffer = _buffer;
		updates = _updates;
		firstslotseqnum = updates[0].getSequenceNumber();
	}

	Slot getSlot(long seqnum) {
		if (seqnum >= firstslotseqnum) {
			int offset = (int) (seqnum - firstslotseqnum);
			if (offset >= updates.length)
				throw new Error("Invalid Slot Sequence Number Reference");
			else
				return updates[offset];
		} else
			return buffer.getSlot(seqnum);
	}
}
